uarua/views/dashboard.py
from flask import Blueprint, render_template
from flask_security import auth_required, current_user

from uarua.models import Event
from uarua.ext import r

dashboard = Blueprint("dashboard", __name__)


@dashboard.route("/")
@auth_required()
def home():
    counter = r.get("live_counter")
    ctx = {
        "events": Event.query.filter(Event.ended_at == None),
        "live": counter.decode("utf-8") if counter else 0,
    }
    return render_template("dashboard.html", **ctx)

uarua/views/destinations.py
from datetime import datetime

from flask import Blueprint, redirect, render_template, request, url_for
from flask_security import auth_required

from uarua.ext import db
from uarua.forms import DestinationForm
from uarua.models import Destination, Event

destination = Blueprint("destination", __name__)


@destination.route("/new/event/<int:event_id>", methods=["GET", "POST"])
@auth_required()
def new(event_id):
    form = DestinationForm()
    if form.validate_on_submit():
        event = Event.query.get_or_404(event_id)
        dest = Destination(
            title=form.title.data,
            stream_url=form.stream_url.data,
            stream_key=form.stream_key.data,
        )
        event.destinations.append(dest)
        db.session.commit()
        return redirect(url_for("event.detail", event_id=event_id))
    return render_template("destination.new.html", form=form)


@destination.route("/delete/<int:destination_id>")
@auth_required()
def delete(destination_id):
    destination = Destination.query.get_or_404(destination_id)
    destination.deleted_at = datetime.utcnow()
    db.session.commit()
    return redirect(request.referrer)

uarua/views/events.py
from uuid import uuid4

from flask import Blueprint, current_app, redirect, render_template, url_for
from flask_security import auth_required, current_user
from sqlalchemy import and_, desc
from sqlalchemy.orm import joinedload, selectinload, subqueryload

from uarua.ext import db
from uarua.forms import EventForm
from uarua.models import Destination, Event, Source

event = Blueprint("event", __name__)


@event.route("/<int:event_id>")
@auth_required()
def detail(event_id):
    ctx = {
        "event": Event.query.get_or_404(event_id),
        "destinations": Destination.query.filter(
            and_(Destination.event_id == event_id, Destination.deleted_at == None)
        ).all(),
        "rtmp_server": f"{current_app.config['RTMP_SERVER']}live",
    }
    return render_template("event.html", **ctx)


@event.route("/list")
@auth_required()
def list_():
    ctx = {"events": Event.query.order_by(desc(Event.created_at)).all()}
    return render_template("event.list.html", **ctx)


@event.route("/new", methods=["GET", "POST"])
@auth_required()
def new():
    form = EventForm()
    if form.validate_on_submit():
        source = Source(title=f"source for {form.title.data}", stream_key=f"{uuid4()}")
        event = Event(
            title=form.title.data,
            description=form.description.data,
            source=source,
            owner=current_user,
        )
        db.session.add(event)
        if form.is_external.data:
            event.source.is_external = form.is_external.data
            event.source.external_url = form.external_url.data
        db.session.commit()
        return redirect(url_for("event.detail", event_id=event.id))
    return render_template("event.new.html", form=form)

uarua/templates/base.html
<!doctype html>
<html lang="en">

<head>
  <!-- Required meta tags -->
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">

  <!-- Bootstrap CSS -->
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css" integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk" crossorigin="anonymous">
  <!-- font-awesome -->
  <script src="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.14.0/js/all.min.js" integrity="sha512-YSdqvJoZr83hj76AIVdOcvLWYMWzy6sJyIMic2aQz5kh2bPTd9dzY3NtdeEAzPp/PhgZqr4aJObB3ym/vsItMg==" crossorigin="anonymous"></script>
   
  <style> 
    .dropdown-toggle::after { 
        display: none !important; 
    } 
  </style>

  <title>Uaruá</title>
</head>

<body>
  <!-- Top Menu-->
  <nav class="navbar navbar-expand-lg navbar-dark" style="background-color: #4e73df">
    <div class="container-sm">
      <a class="navbar-brand" href="{{ url_for('dashboard.home') }}">Uaruá</a>
      <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarsExample07"
        aria-controls="navbarsExample07" aria-expanded="false" aria-label="Toggle navigation">
        <span class="navbar-toggler-icon"></span>
      </button>
      {% if current_user.is_authenticated %}
      <div class="collapse navbar-collapse" id="navbarsExample07">
        <ul class="navbar-nav mr-auto mb-2 mb-lg-0">
          <li class="nav-item">
            <a class="nav-link" href="{{ url_for('event.list_') }}">Transmissões</a>
          </li>
        </ul>
        <ul class="navbar-nav">
          <!-- Nav Item - User Information -->
          <li class="nav-item dropdown no-arrow">
            <a class="nav-link dropdown-toggle" href="#" id="userDropdown" role="button" data-toggle="dropdown"
              aria-haspopup="true" aria-expanded="false">
              <span class="mr-2 d-none d-lg-inline text-gray-600 small">{{ current_user.email }}</span>
              <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <!-- Dropdown - User Information -->
            <div class="dropdown-menu dropdown-menu-right shadow animated--grow-in" aria-labelledby="userDropdown">
              <a class="dropdown-item disabled" href="#">
                <i class="fas fa-user fa-sm fa-fw mr-2 text-gray-400"></i>
                Profile
              </a>
              <a class="dropdown-item" href="#">
                <i class="fas fa-cogs fa-sm fa-fw mr-2 text-gray-400"></i>
                Auth Setup
              </a>
              <a class="dropdown-item disabled" href="#">
                <i class="fas fa-list fa-sm fa-fw mr-2 text-gray-400"></i>
                Activity Log
              </a>
              <div class="dropdown-divider"></div>
              <a class="dropdown-item" href="{{ url_for('security.logout') }}">
                <i class="fas fa-sign-out-alt fa-sm fa-fw mr-2 text-gray-400"></i>
                Logout
              </a>
            </div>
          </li>

        </ul>
      </div>
      {% endif %}
    </div>
  </nav>
  <main class="container py-5 px-2">
    {% block content %}
    {% endblock %}
  </main>
  <!-- Optional JavaScript -->
  <!-- jQuery first, then Popper.js, then Bootstrap JS -->
  <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.min.js" integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0=" crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
  <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/js/bootstrap.min.js" integrity="sha384-OgVRvuATP1z7JjHLkuOU7Xw704+h835Lr+6QL9UvYjZE3Ipu6Tp75j7Bh/kR0JKI" crossorigin="anonymous"></script>
</body>

</html>

uarua/templates/dashboard.blank.html
{% extends "base.html" %}
{% block content %}
<!-- Page Wrapper -->
<div id="wrapper">

  <!-- Content Wrapper -->
  <div id="content-wrapper" class="d-flex flex-column">

    <!-- Main Content -->
    <div id="content">

      <!-- Begin Page Content -->
      <div class="container-fluid">

        {% block dashboard_content %}
        <!-- Page Heading -->
        <h1 class="h3 mb-4 text-gray-800">Blank Page</h1>
        {% endblock %}

      </div>
      <!-- /.container-fluid -->

    </div>
    <!-- End of Main Content -->

    <!-- Footer -->
    <footer class="sticky-footer bg-white">
    </footer>
    <!-- End of Footer -->

  </div>
  <!-- End of Content Wrapper -->

</div>
<!-- End of Page Wrapper -->

{% endblock %}

uarua/templates/dashboard.html
{% extends "dashboard.blank.html" %}

{% block dashboard_content %}
<!-- Page Heading -->
<h1 class="h3 mb-4 text-gray-800">Dashboard</h1>
<div class="row">
    <div class="col-xl-9 col-lg-7">
        <div class="card shadow mb-4">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">Transmissões</h6>
                <div class="no-arrow">
                    <a href="{{ url_for('event.new') }}" class="btn btn-primary btn-icon-split btn-sm">
                        <span class="icon text-white-50">
                            <i class="fas fa-plus"></i>
                        </span>
                        <span class="text">Nova Transmissão</span>
                    </a>
                </div>
            </div>
            <div class="card-body">
                <table class="table table-sm">
                    <thead>
                        <tr>
                            <th scope="col">Título</th>
                            <th scope="col">Criado</th>
                            <th scope="col">Agendado</th>
                            <th scope="col"></th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for e in events %}
                        <tr>
                            <td>
                                <div class="media">
                                    <div class="media-body small">
                                        <div class="d-flex justify-content-between align-items-center w-100">
                                            <strong class="text-gray-dark">
                                                <a href="{{ url_for('event.detail', event_id=e.id) }}">
                                                    {{ e.title }}
                                                </a>
                                            </strong>
                                        </div>
                                    </div>
                                </div>
                            </td>
                            <td>
                                <span
                                    class="d-block text-muted small">{{ e.created_at.strftime("%d %B %Y %I:%M%p") }}</span>
                            </td>
                            <td>
                                {% if e.start_at %}
                                <span
                                    class="d-block text-muted small">{{ e.start_at.strftime("%d %B %Y %I:%M%p") }}</span>
                                {% else %}
                                <span class="d-block text-muted small">---</span>
                                {% endif %}
                            </td>
                            <td>
                                <div class="dropdown no-arrow">
                                    <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
                                        data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                                    </a>
                                    <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                                        aria-labelledby="dropdownMenuLink">
                                        <div class="dropdown-header">Opções</div>
                                        <a class="dropdown-item" onclick="eventDone({{ e.id }})" style="color: #3a3b45;">
                                            <i class="fas fa-check fa-sm fa-fw"></i>
                                            Desativar
                                        </a>
                                        <a class="dropdown-item disabled">
                                            <i class="fas fa-trash fa-sm fa-fw" style="color: Red;"></i>
                                            Remover
                                        </a>
                                    </div>
                                </div>
                            </td>
                        </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
    </div>
    <div class="col-xl-3 col-lg-5">
        <div class="card border-left-success shadow py-2">
            <div class="card-body">
                <div class="row no-gutters align-items-center">
                    <div class="col mr-2">
                        <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">Ao Vivo</div>
                        <div class="h5 mb-0 font-weight-bold text-gray-800">{{ live }}</div>
                    </div>
                    <div class="col-auto">
                        <i class="fas fa-video fa-2x text-green"></i>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="{{ url_for('static', filename='js/uarua.js') }}"></script>
{% endblock %}

uarua/templates/destination.new.html
{% extends "dashboard.blank.html" %}

{% block dashboard_content %}
<div class="d-sm-flex mb-4">
    <h1 class="h3 mb-0 text-gray-800">Novo Destino</h1>
    </a>
</div>
<div class="row justify-content-start">
    <div class="col-4">
        <div class="card shadow mb-4">
            <div class="card-header py-3">
                <h6 class="m-0 font-weight-bold text-primary">Informações</h6>
            </div>
            <div class="card-body">
                <form method="POST" action="">
                    {{ form.csrf_token }}
                    <div class="form-group row">
                        {{ form.title.label(class='col-3 col-form-label') }}
                        <div class="col-9">{{ form.title }}</div>
                    </div>
                    <div class="form-group row">
                        {{ form.stream_url.label(class='col-3 col-form-label') }}
                        <div class="col-9">{{ form.stream_url }}</div>
                    </div>
                    <div class="form-group row">
                        {{ form.stream_key.label(class='col-3 col-form-label') }}
                        <div class="col-9">{{ form.stream_key }}</div>
                    </div>
                    <input type="submit" value="Go">
                </form>
            </div>
        </div>
    </div>
</div>
{% endblock %}

uarua/templates/event.html
{% extends "dashboard.blank.html" %}

{% block dashboard_content %}
<div class="container">
    <div class="d-sm-flex align-items-center justify-content-between mb-4">
        <h1 class="h3 mb-0 text-gray-800">{{ event.title }}</h1>
        {% if event.can_stream %}
        <a href="{{ url_for('action.publish-event', event_id=event.id) }}"
            class="btn btn-success btn-icon-split btn-sm">
            <span class="icon">
                <i class="fas fa-play"></i>
            </span>
            <span class="text">Transmitir</span>
        </a>
        {% endif %}
    </div>
    {% if not event.source.is_external %}
    <div class="row">
        <div class="col-xl-4 col-lg-5">
            <div class="card shadow mb-4">
                <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                    <h6 class="m-0 font-weight-bold text-primary"">
                        Preview
                    </h6>
                    <div class=" no-arrow">
                        {% if event.source.is_live %}
                        <span class="badge badge-pill badge-success">recebendo</span>
                        {% else %}
                        <span class="badge badge-pill badge-danger">offline</span>
                        {% endif %}
                </div>
            </div>
            
            <div class="card-body">
                {% if event.source.is_live %}
                <video id="my-video" class="video-js vjs-default-skin vjs-big-play-centered" controls
                    data-setup='{"aspectRatio":"16:9", "preload": "none"}'>
                    <source src="{{ event.source.preview_url }}"
                        type="application/x-mpegURL" />
                    <p class="vjs-no-js">
                        To view this video please enable JavaScript, and consider upgrading to a
                        web browser that
                        <a href="https://videojs.com/html5-video-support/" target="_blank">supports HTML5 video</a>
                    </p>
                </video>
                {% endif %}
            </div>
            <div class="card-body">
                ** qualidade do vídeo **
            </div>
        </div>
    </div>
    {% endif %}
    {% if event.source.is_external %}
    <div class="col">
    {% else %}
    <div class="col-8">
    {% endif %}
        <div class="card shadow mb-4">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">Informações</h6>
                <a href="{{ url_for('event.detail', event_id=event.id) }}" class="btn btn-sm btn-outline-primary">
                    <i class="fas fa-sync fa-sm text-grey-50"></i>
                </a>
            </div>
            <div class="card-body">
                {% if event.source.is_external %}
                <div class="row">
                    <div class="col-4">Origem:</div>
                    <div class="col-8">{{ event.source.external_url }}</div>
                </div>
                {% else %}
                <div class="row">
                    <div class="col-4">Servidor:</div>
                    <div class="col-8">{{ rtmp_server }}</div>
                </div>
                <div class="row">
                    <div class="col-4">Chave de transmissão: </div>
                    <div class="col-8">{{ event.source.stream_key }}</div>
                </div>
                {% endif %}
            </div>
        </div>
        <div class="card shadow mb-4">
            <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                <h6 class="m-0 font-weight-bold text-primary">Destinos</h6>
                <div class="no-arrow">
                    <a href="{{ url_for('destination.new', event_id=event.id) }}"
                        class="btn btn-primary btn-icon-split btn-sm">
                        <span class="icon text-white-50">
                            <i class="fas fa-plus"></i>
                        </span>
                        <span class="text">Adicionar</span>
                    </a>
                </div>
            </div>
            <div class="card-body">
                <table class="table table-fluid">
                    <thead>
                        <tr>
                            <th scope="col">Title</th>
                            <th scope="col">Criado</th>
                            <th scope="col"></th>
                            <th scope="col"></th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for d in destinations %}
                        <tr>
                            <th>
                                <strong class="text-gray-dark">{{ d.title }}</strong>
                                {% if d.is_live %}
                                <span class="badge badge-pill badge-success">live</span>
                                {% elif d.is_queued %}
                                <span class="badge badge-pill badge-info">na fila</span>
                                {% endif %}
                            </th>
                            <td>
                                <span
                                    class="d-block text-muted small">{{ d.created_at.strftime("%d %B %Y %I:%M%p") }}</span>
                            </td>
                            <td>
                                {% if event.can_stream %}
                                {% if d.is_live %}
                                <a href="{{ url_for('action.stop-destination', event_id=event.id, destination_id=d.id) }}"
                                    class="btn btn-danger btn-icon-split btn-sm text-white">
                                    <span class="icon text-white-50">
                                        <i class="fas fa-stop"></i>
                                    </span>
                                    <span class="text">Parar</span>
                                </a>
                                {% else %}
                                <a href="{{ url_for('action.publish-destination', event_id=event.id, destination_id=d.id) }}"
                                    class="btn btn-success btn-icon-split btn-sm  text-white" data-toggle="tooltip"
                                    data-placement="top" title="Iniciar transmissão">
                                    <span class="icon">
                                        <i class="fas fa-play"></i>
                                    </span>
                                    <span class="text">Transmitir</span>
                                </a>
                                {% endif %}
                                {% endif %}
                            </td>
                            <td>
                                <div class="btn-group">
                                    <a href="{{ url_for('destination.delete', destination_id=d.id) }}"
                                        class="btn btn-sm btn-outline-danger" data-toggle="tooltip" data-placement="top"
                                        title="Remover">
                                        <i class="fas fa-trash fa-sm text-grey-50"></i>
                                    </a>
                                    <a href="/" class="btn btn-sm btn-outline-secondary" data-toggle="tooltip"
                                        data-placement="top" title="Iniciar transmissão">
                                        <i class="fas fa-edit fa-sm text-grey-50"></i>
                                    </a>
                                </div>
                            </td>
                        </tr>
                        {% endfor %}
                    </tbody>
                </table>

            </div>
        </div>
    </div>
</div>
<link href="https://unpkg.com/video.js/dist/video-js.css" rel="stylesheet">
<script src="https://unpkg.com/video.js/dist/video.js"></script>
{% endblock %}

uarua/templates/event.list.html
{% extends "dashboard.blank.html" %}
{% block dashboard_content %}
<div class="container">
    <div class="col-fluid">
        <h1 class="h3 mb-4 text-gray-800">Transmissões</h1>
        <div class="col-fluid">
            <div class="card shadow mb-4">
                <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
                    <h6 class="m-0 font-weight-bold text-primary">Transmissões</h6>
                    <div class="no-arrow">
                        <a href="{{ url_for('event.new') }}" class="btn btn-primary btn-icon-split btn-sm">
                            <span class="icon text-white-50">
                                <i class="fas fa-plus"></i>
                            </span>
                            <span class="text">Nova Transmissão</span>
                        </a>
                    </div>
                </div>
                <div class="card-body">
                    <table class="table table-sm">
                        <thead>
                            <tr>
                                <th scope="col">Título</th>
                                <th scope="col">Criado</th>
                                <th scope="col">Agendado</th>
                                <th scope="col"></th>
                            </tr>
                        </thead>
                        <tbody>
                            {% for e in events %}
                            <tr>
                                <td>
                                    <div class="media">
                                        <div class="media-body small">
                                            <div class="d-flex justify-content-between align-items-center w-100">
                                                <strong class="text-gray-dark">
                                                    <a href="{{ url_for('event.detail', event_id=e.id) }}">
                                                        {{ e.title }}
                                                    </a>
                                                    {% if e.ended_at %}
                                                    <span class="badge badge-pill badge-secondary">encerrado</span>
                                                    {% endif %}
                                                </strong>
                                            </div>
                                        </div>
                                    </div>
                                </td>
                                <td>
                                    <span
                                        class="d-block text-muted small">{{ e.created_at.strftime("%d %B %Y %I:%M%p") }}</span>
                                </td>
                                <td>
                                    {% if e.start_at %}
                                    <span
                                        class="d-block text-muted small">{{ e.start_at.strftime("%d %B %Y %I:%M%p") }}</span>
                                    {% else %}
                                    <span class="d-block text-muted small">---</span>
                                    {% endif %}
                                </td>
                                <td>
                                    <div class="dropdown no-arrow">
                                        <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink"
                                            data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                            <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
                                        </a>
                                        <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in"
                                            aria-labelledby="dropdownMenuLink" style="">
                                            <div class="dropdown-header">Opções</div>
                                            <a class="dropdown-item" href="#">
                                                <i class="fas fa-trash fa-sm fa-fw" style="color: Red;"></i>
                                                Remover
                                            </a>
                                        </div>
                                    </div>
                                </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>

</div>
<link href="https://unpkg.com/video.js/dist/video-js.css" rel="stylesheet">
<script src="https://unpkg.com/video.js/dist/video.js"></script>
{% endblock %}

uarua/templates/event.new.html
{% extends "dashboard.blank.html" %}

{% block dashboard_content %}

<div class="d-sm-flex mb-4">
    <h1 class="h3 mb-0 text-gray-800">Nova Transmissão</h1>
    </a>
</div>
<div class="row justify-content-start">
    <div class="col-6">
        <div class="card shadow mb-4">
            <div class="card-header py-3">
                <h6 class="m-0 font-weight-bold text-primary">Informações</h6>
            </div>
            <div class="card-body">
                <form method="POST" action="{{ url_for('event.new') }}">
                    {{ form.csrf_token }}
                    <div class="form-group row">
                        {{ form.title.label(class='col-3 col-form-label') }}
                        <div class="col-9">{{ form.title }}</div>
                    </div>
                    <div class="form-group row">
                        {{ form.description.label(class='col-3 col-form-label') }}
                        <div class="col-9">
                            {{ form.description }}
                        </div>
                    </div>
                    <div class="form-checks">
                        {{ form.is_external(class="form-check-input") }}
                        {{ form.is_external.label(class="form-check-label") }}
                    </div>
                    <div class="form-group row">
                        {{ form.external_url.label(class='col-3 col-form-label') }}
                        <div class="col-9">
                            {{ form.external_url }}
                        </div>
                    </div>
                    <input type="submit" value="Go">
                </form>
            </div>
        </div>
    </div>
</div>

{% endblock %}

uarua/templates/source.new.html
{% extends "dashboard.blank.html" %}

{% block dashboard_content %}

<div class="d-sm-flex mb-4">
    <h1 class="h3 mb-0 text-gray-800">Nova Transmissão</h1>
    </a>
</div>
<div class="row justify-content-start">
    <div class="col-4">
        <div class="card shadow mb-4">
            <div class="card-header py-3">
                <h6 class="m-0 font-weight-bold text-primary">Informações</h6>
            </div>
            <div class="card-body">
                <form method="POST" action="{{ url_for('views.event_new') }}">
                    {{ form.csrf_token }}
                    <div class="form-group row">
                        {{ form.title.label(class='col-3 col-form-label') }}
                        <div class="col-9">{{ form.title }}</div>
                    </div>
                    <div class="form-group row">
                        {{ form.description.label(class='col-3 col-form-label') }}
                        <div class="col-9">
                            {{ form.description }}
                        </div>
                    </div>
                    <input type="submit" value="Go">
                </form>
            </div>
        </div>
    </div>
</div>

{% endblock %}